# ================= TDMA DAMA ================================

#  Attaches error model to interface "index" (by default, the first one)
Node/SatNode instproc interface-errormodel { em { index 0 } } {
	$self instvar mac_ ll_ em_ linkhead_
	set pp [$mac_($index) up-target]
	$mac_($index) up-target $em
	$em target $pp
	$em drop-target [new Agent/Null]; # otherwise, packet is only marked
	set em_($index) $em
	$linkhead_($index) seterrmodel $em
} 

Node/SatNode instproc insert-monitor { {index_ 0}} {
	$self instvar qMonitor_ snoopIn_ snoopOut_ snoopDrop_
	$self instvar ll_ ifq_ drophead_ bytesInt_ pktsInt_ requester_

	set snoopIn_($index_)   [new SnoopQueue/In]
	set snoopOut_($index_)  [new SnoopQueue/Out]
	set snoopDrop_($index_) [new SnoopQueue/Drop]

	$snoopIn_($index_) target [$ll_($index_) down-target]	
	$ll_($index_) down-target $snoopIn_($index_)

	$snoopOut_($index_) target [$ifq_($index_) target]
	$ifq_($index_) target $snoopOut_($index_)

	$snoopDrop_($index_) target [$drophead_($index_) target]
	$drophead_($index_) target $snoopDrop_($index_)
	$ifq_($index_) drop-target $snoopDrop_($index_)

	set bytesInt_($index_) [new Integrator]
	$qMonitor_($index_) set-bytes-integrator $bytesInt_($index_)

	set pktsInt_($index_) [new Integrator]
	$qMonitor_($index_) set-pkts-integrator $pktsInt_($index_)

	$requester_ set qMonitor_ $qMonitor_($index_)

	$snoopIn_($index_) set-monitor $qMonitor_($index_)
	$snoopOut_($index_) set-monitor $qMonitor_($index_)
	$snoopDrop_($index_) set-monitor $qMonitor_($index_)
} 


Mac/TdmaDama set slot_packet_len_ 1500
Mac/TdmaDama set max_node_num_ 64
Mac/TdmaDama set abw_ 0
Mac/TdmaDama set util_weight_ 10
Mac/TdmaDama set enableQS_ 0
Mac/TdmaDama set dump_alloc_ 0
Mac/TdmaDama set algorithm_ 2
Mac/TdmaDama set delayQS_ 0
Mac/TdmaDama set aligned_ 1
Mac/TdmaDama set corrupted_slots_ 0
Mac/TdmaDama set used_slots_ 0
Mac/TdmaDama set successful_slots_ 0
Mac/TdmaDama set total_slots_ 0
Mac/TdmaDama set fixed_frame_ 0
Mac/TdmaDama set slots1_ 20
Mac/TdmaDama set offset_ 0
Mac/TdmaDama set hub_ 0
Mac/TdmaDama set num_frame_ 1
Mac/TdmaDama set m_frame_ 1
Mac/TdmaDama set fragsize_ 184
Mac/TdmaDama set slot_num_ 0

Node/SatNode instproc install-requester { type {index_ 0} } {
	$self instvar mac_ requester_ ifq_ qMonitor_ id_

	set qMonitor_($index_) [new QueueMonitor]	
	if {[info exist mac_($index_)]} {
		set requester_ [new $type]
		$requester_ attach $mac_($index_)
		$requester_ setifq $ifq_($index_)
		$requester_ set ifq_ $ifq_($index_)
		$requester_ set id_ $id_
		$requester_ set node_ $self
		$self insert-monitor $index_
	}
	$requester_ setmon $qMonitor_($index_)
	return $requester_
}

Node/SatNode instproc install-allocator {type {index_ 0} } {
	$self instvar mac_ allocator_
	if {[info exist mac_($index_)]} {
		set allocator_ [new $type]
		$allocator_ attach $mac_($index_)
	}
	return $allocator_
}

Node/SatNode instproc trace-event { filedes {index_ 0}} {
	$self instvar mac_ et_
	if {[info exist mac_($index_)]} {
		set et_ [new BaseTrace/Event]
		$et_ attach $filedes
		$mac_($index_) eventtrace $et_
	}
	return $et_	
}

Node/SatNode instproc insert-sat-ttl { {index_ 0} } {
        $self instvar ifq_ ttl_
        if {[info exist ifq_($index_)] } {
                set ttl_($index_) [new TTLChecker]
                set tgt [$ifq_($index_) target]
                $ifq_($index_) target $ttl_($index_)
                $ttl_($index_) target $tgt
        }
}

Allocator/Tcl instproc initvar { } { 
	# nothing
}

Allocator/Tcl instproc allocation { } {
	puts stderr "warning: allocation function undefined" 
	exit
}

Requester/Tcl instproc initvar { } {
	#nothing
}

Requester/Tcl instproc dorequest  { } { 
	puts stderr "warning: dorequest function undefined"
	exit
}

Allocator/Proportional set delay_ 1.6
Allocator/Proportional set active_node_ 0
Allocator/Proportional set max_slot_num_ 64

Allocator/FODA set delay_ 1.6
Allocator/FODA set active_node_ 0
Allocator/FODA set max_slot_num_ 64
Allocator/FODA set def_slots_ 0
Allocator/FODA set ming_ 1
Allocator/FODA set k_frame_ 1.0
Allocator/FODA set xpercent_ 0.1
Allocator/FODA set ignore_loss_ 0
Allocator/FODA set hub_ 0
Allocator/FODA set debug_ 0

Allocator/Tcl set delay_ 1.6
Allocator/Tcl set active_node_ 0
Allocator/Tcl set max_slot_num_ 64

Requester/Constant set request_ 1
Requester/RBDC set request_ 1
Requester/VBDC set request_ 1
Requester/Tcl set request_ 1
Requester/RVBDC set request_ 1

Requester/Constant set totQSreq_ 0
Requester/RBDC set totQSreq_ 0
Requester/VBDC set totQSreq_ 0
Requester/Tcl set totQSreq_ 0
Requester/RVBDC set totQSreq_ 0
Requester/RVBDC set alpha_ 0.5
Requester/RVBDC set min_rvbdc_ 0
Requester/RVBDC set max_rvbdc_ 100000
Requester/RVBDC set k_ 1.0 

